﻿
//    //\\  HTML-element and JavaScript wrapper
//          	Adds HTML element flying on top over game-canvas.
//				Wraps some DOM and JavaScript into c2.
//
//          Modified from c2 core "Button" plugin.
//
//			THIS PLUGIN IS EXPERIMENTAL.
//          NOT ALL PARTS OF C2-PLUGIN FUNCTIONALITY ARE UNDERSTOOD BY AUTHOR
//          NOT ALL METHODS ARE TESTED OR WELL-DOCUMENTET.
//          POSSIBLY GOOD FOR PROTOTYPNG OR FURTHER MODIFICATIONS
//
//			License. If it is permittable to make it MIT, i'll do this.
//			I am not sure because, this is modified "Button" core c2 plugin and
//			its license is unknow to me. If core developer will drop me
//			a not to my c2 @ landkey . net email, i'll appreciate this.
//
//			NOT SURE "Google Minifier" c2-option at export is satisfied;
//			https://developers.google.com/closure/compiler/docs/limitations
//			but project-export-minifier passes without errors;
//
//
//          Possibly needs to strip or avoid methods as SetFocus, ... which
//          possibly not supported by all html-elements like <span>, <br>, ...
//          These methods should be stripped, because this plugin tends to be generic
//          with any methods in the future ...
//
//
//          I don't understand everything in original template, i am just a beginner ...
//          i put questions ... 
//          if you elaborate this plugin further and have answers, i'll apreciate
//          dropping me the answer to my email which is:
//			c2 @ landkey . net
//			Thank you.
//
//			Version 1.0	allows creation of an arbitrary HTML-element at edit time.
//
//			Version 1.1 allows call and return from html-methods; 
//	                    Return value can be any object.
//
//			Varsion 1.2. August 23, 2014.
//			Varsion 1.3. August 27, 2014. Action "assign" bug fix.
//			Varsion 1.4. September 16, 2014. When returning from method or generic JavaScript function, 
//							returns "" or "1" depending on !!value when value is object, ...
//							because cannot make c2 to return object
//			Varsion 1.5. October 1, 2014. Attempt to comply v8-based-minifier has been made.
//			Varsion 1.6. October 19, 2014. Append-global-css added to action to "Browser" section.
//                                         Dynamically and as a property.
//			
//
//			Has c2-actions wrapping JavaScript functionality:
//				call			- call functions on string arguments
//				json2path		- converts json-string to object and assigns this object to node window.path
//              jq       	  	- calls jQuery.method()
//              assign      	- assigns window.detinationPath = window.departurePath like window.moo.x = window.boo.y;
//              ret2path   		- assigns window.detinationPath = this.ret.departurePath
//
//			Has c2-actions wrapping this htmel DOM functionality:
//              set property    - htmel.path = string
//              method call    	- window.path = htmel.method( string-arguments )
//              jqel       		- window.path = jQuery( htmel ).method( string-arguments )
//              set innerHTML 	- htmel.path = string
//              set globalCSS 	- as property or
//              load globalCSS 	- dynamically
//
//			Has c2-expressions wrapping JavaScript functionality:
//				coll			- call functions on string arguments
//              path            - gets window.path
//              get             - gets htmel.path
//              path2json       - gets JSON.stringify( window.path )
//
//			Has c2-expressions wrapping htmel DOM functionality:
//				getInlineCssText - htmel.style.cssText
//          	ret
//              jqel
//              jq  
//
//          Has also actions remained from original "Button" plugin.



function GetPluginSettings()
{
	return {
		"name":			"HtmEl",
		"id":			"HtmEl",
		"version":		"1.6",
		"description":	"An arbitrary html element to put over top of canvas",
		"author":		"License MIT. Contributor Copyright 2014 Konstantin Kirillov. Modified Scirra's Button core-plugin.",
		"help url":		"http://landkey.net/sand/c2/plugins",
		"category":		"Web",
		"type":			"world",			// appears in layout	TODM wis?
		"rotatable":	false,
		"flags":		pf_position_aces | pf_size_aces
	};
};





//:  Parameter types
// AddNumberParam(label, description [, initial_string = "0"])			// a number
// AddStringParam(label, description [, initial_string = "\"\""])		// a string
// AddAnyTypeParam(label, description [, initial_string = "0"])			// accepts either a number or string
// AddCmpParam(label, description)										// combo with equal, not equal, less, etc.
// AddComboParamOption(text)											// (repeat before "AddComboParam" to add combo items)
// AddComboParam(label, description [, initial_selection = 0])			// a dropdown list parameter
// AddObjectParam(label, description)									// a button to click and pick an object type
// AddLayerParam(label, description)									// accepts either a layer number or name (string)
// AddLayoutParam(label, description)									// a dropdown list with all project layouts
// AddKeybParam(label, description)										// a button to click and press a key (returns a VK)
// AddAnimationParam(label, description)								// a string intended to specify an animation name
// AddAudioFileParam(label, description)								// a dropdown list with all imported project audio files







//    //\\    Conditions    //////////////////////////////////
// AddCondition(id,					// any positive integer to uniquely identify this condition
//				flags,				// (see docs) cf_none, cf_trigger, cf_fake_trigger, cf_static, cf_not_invertible,
//									// cf_deprecated, cf_incompatible_with_triggers, cf_looping
//				list_name,			// appears in event wizard list
//				category,			// category in event wizard list
//				display_str,		// as appears in event sheet - use {0}, {1} for parameters and also <b></b>, <i></i>
//				description,		// appears in event wizard dialog when selected
//				script_name);		// corresponding runtime function name
				
AddCondition(0, cf_trigger, "On clicked", "HtmEl", "On clicked", "Triggered when the button is clicked.", "OnClicked");
//    \\//    Conditions    //////////////////////////////////





//    //\\    Actions    //////////////////////////////////

// AddAction(id,				// any positive integer to uniquely identify this action
//			 flags,				// (see docs) af_none, af_deprecated
//			 list_name,			// appears in event wizard list
//			 category,			// category in event wizard list
//			 display_str,		// as appears in event sheet - use {0}, {1} for parameters and also <b></b>, <i></i>
//			 description,		// appears in event wizard dialog when selected
//			 script_name);		// corresponding runtime function name

AddStringParam("innerHTML", "The innerHTML to set in the element.");
AddAction(0, af_none, "Set innerHTML", "HtmEl", ".innerHTML = {0}", "Set innerHTML", "SetInnerHTML");

AddStringParam("Tooltip", "The tooltip to set on the button.");
AddAction(1, af_none, "Set tooltip", "HtmEl", "Set tooltip to {0}", "Set the button's tooltip.", "SetTooltip");

AddComboParamOption("Invisible");
AddComboParamOption("Visible");
AddComboParam("Visibility", "Choose whether to hide or show the button.");
AddAction(2, af_none, "Set visible", "Appearance", "Set <b>{0}</b>", "Hide or show the button.", "SetVisible");


AddComboParamOption("Disabled");
AddComboParamOption("Enabled");
AddComboParam("Mode", "Choose whether to enable or disable the button.");
AddAction(3, af_none, "Set enabled", "HtmEl", "Set <b>{0}</b>", "Disable or enable the button.", "SetEnabled");

AddAction(4, af_none, "Set focused", "HtmEl", "Set focused", "Set the input focus to the button.", "SetFocus");


AddStringParam("Property name", "A CSS property name to set on the control.", "\"color\"");
AddStringParam("Value", "A string to assign as the value for this CSS property.", "\"red\"");
AddAction(5, af_none, "Set CSS style", "Appearance", "Set CSS style {0} to {1}", "Set a CSS style on the control.", "SetCSSStyle");

AddAction(6, af_none, "Set unfocused", "HtmEl", "Set unfocused", "Remove the input focus from the button.", "SetBlur");

AddStringParam("element's full inline style", "A SetInlineCssText on the element.");
AddStringParam("None", "Has not effect. No value is required.");
AddAction(7, af_none, "Set Set Inline Css Text for entire element", "Appearance", "Set SetInlineCssText {0} to {1}", "Set Set Inline Css Text on the entire element.", "SetInlineCssText");





//: calls generic function
AddStringParam("function", "function path");
AddStringParam("arguments", "arg1 arg2 arg3 ... ");
AddStringParam("destination path, optional", "destination path, optional");
AddAction(8, af_none, "call", "JavaScript", "window.{2} = window.{0}({1})", "call", "coll");

//: calls html-element method and assigns results to the path
AddStringParam("method", "method path");
AddStringParam("arguments", "arg1 arg2 arg3 ... ");
AddStringParam("destination path, optional", "destination path, optional");
AddAction(9, af_none, "method call", "HtmEl", "[{2}]=htmel.{0}({1})", "calls method and assignm result", "elMethod");

// TODM possibly garbage: jq can do this
AddStringParam("propPath", "propPath");
AddStringParam("value as string", "value as string");
AddAction(10, af_none, "set property", "HtmEl", ".{0} = {1} ", "set", "elSet");

AddStringParam("method", "method path");
AddStringParam("arguments", "arg1 arg2 arg3 ... ");
AddAction(11, af_none, "jqel", "HtmEl", "jqel.{0}({1})", "calls method and assigns result", "jqel");

AddStringParam("method", "method path");
AddStringParam("arguments", "arg1 arg2 arg3 ... ");
AddStringParam("destination path", "destination path");
AddAction(12, af_none, "jq", "JavaScript", "window.{2} = jq.{0}({1})", "calls method and assigns result", "jq");

AddStringParam("destination path", "where to put value relative to window; value of any JS-type");
AddStringParam("departure path", "where to get value relative to window; value of any JS-type");
AddAction(13, af_none, "assignFromPath", "JavaScript", "window.{0} = window.{1} ", "Make a reference assignment and also stash it in this.ret", "assByPath");

AddStringParam("json string", "json string");
AddStringParam("destination path", "where to put object parsed from json;");
AddAction(14, af_none, "json2path", "JavaScript", "window.{1} = JSON.parse({0}) ", "json string to node at path", "json2path");

AddStringParam("destination path", "jdestination path");
AddStringParam("departure path", "departure path");
AddAction(15, af_none, "ret2path", "JavaScript", "window.{0} = this.ret.{1} ", "returned value to destination path", "ret2path");

AddStringParam("destination path", "where to put value relative to window; value of any JS-type");
AddStringParam("primitive value", "where to get value relative to window; value of any JS-type");
AddAction(16, af_none, "assignPrimitive", "JavaScript", "window.{0} = {1} ", "Make a reference assignment and also stash it in this.ret", "assPrimitive");

AddStringParam(		"text", "URL or path to global css for entire page" );
AddAction( 17, 0, "load css for doc. body", "Browser", "load {0} ", "Injects global css", "appendCSS"); //TODO not sure about right flags

AddStringParam(		"text", "global CSS text to be injected into entire page" );
AddAction( 18, 0, "add css for doc. body", "Browser", "global CSS = {0} ", "Injects global css from text", "appendCSSFromText"); //TODO not sure about right flags


//    \\//    Actions    //////////////////////////////////






//    //\\    Expressions    //////////////////////////////////

// AddExpression(id,			// any positive integer to uniquely identify this expression
//				 flags,			// (see docs) ef_none, ef_deprecated, ef_return_number, ef_return_string,
//								// ef_return_any, ef_variadic_parameters (one return flag must be specified)
//				 list_name,		// currently ignored, but set as if appeared in event wizard
//				 category,		// category in expressions panel
//				 exp_name,		// the expression name after the dot, e.g. "foo" for "myobject.foo" - also the runtime function name
//				 description);	// description in expressions panel

AddExpression(	0,
				ef_return_string,
				"get Inline Css Text",
				"getInlineCssText",
				"getInlineCssText",
				"Return the InlineCssText."
);



AddStringParam(	"path to retrieved descendant in respect to window", "path to retrieved descendant in respect to window", "");
AddExpression(	1,
				ef_return_string,
				"path",
				"path",
				"path",
				"Return descendant-at-path"
);



AddStringParam("function", "function path");
AddStringParam("arguments", "arg1 arg2 arg3 ... ");
AddExpression(	2,
				ef_return_any | ef_variadic_parameters,	// TODM what is variadic, why not string|number? bs other options do not exist anyway?
				"calls and returns primitive at result.path",
				"coll",
				"coll",
				"calls and returns primitive at result.path"
);


AddStringParam("method", "method path");
AddStringParam("arguments", "arg1 arg2 arg3 ... ");
AddExpression(	3,
				ef_return_any | ef_variadic_parameters,	// TODM what is variadic, why not string|number? bs other options do not exist anyway?
				"calls and returns primitive at result.path",
				"method",
				"method",
				"calls and returns primitive at result.path"
);

AddStringParam(	"path", "The path for primitive in function result", "");
AddExpression(	4,
				ef_return_any | ef_variadic_parameters,	// TODM what is variadic, why not string|number? bs other options do not exist anyway?
				"return primitive at result.path",
				"ret",
				"ret",
				"return primitive at result.path"
);


AddStringParam("method", "method path");
AddStringParam("arguments", "arg1 arg2 arg3 ... ");
AddExpression(	5,
				ef_return_any | ef_variadic_parameters,	// TODM what is variadic, why not string|number? bs other options do not exist anyway?
				"calls and returns primitive at result.path",
				"jqel",
				"jqel",
				"calls and returns primitive at result.path"
);


AddStringParam("method", "method path");
AddStringParam("arguments", "arg1 arg2 arg3 ... ");
AddExpression(	6,
				ef_return_any | ef_variadic_parameters,	// TODM what is variadic, why not string|number? bs other options do not exist anyway?
				"calls and returns primitive at result.path",
				"jq",
				"jq",
				"calls and returns primitive at result.path"
);




AddStringParam(	"window.path to value", "window.path to value", "");
AddExpression(	7,
				ef_return_any,
				"path2json",
				"path2json",
				"path2json",
				"Return descendant-at-path as JSON object"
);



///	
AddStringParam(		"path to own descendant",
					"gets this.path, stashes in this.ret, and returns as primitive if any;", "");
AddExpression(	8,
				ef_return_string,
				"get",
				"get",
				"get",
				"Return own descendant-at-path"
);

//    \\//    Expressions    //////////////////////////////////




ACESDone();



// Property grid properties for this plugin
var property_list = [
	new cr.Property(ept_text,	"Type",					"div",		"The kind of html to create 'div', 'script', 'img', ..." ),
	new cr.Property(ept_text,	"innerHTML",			"",			"The initial text for the html-element box."),
	new cr.Property(ept_text,	"Tooltip",				"",			"Display this text when hovering the mouse over the control."),
	new cr.Property(ept_combo,	"Initial visibility",	"Visible",	"Choose whether the text box is visible on startup.", "Invisible|Visible"),
	new cr.Property(ept_combo,	"Enabled",				"Yes",		"Choose whether the text box is enabled or disabled on startup.", "No|Yes"),
	new cr.Property(ept_combo,	"Auto font size",		"Yes",		"Automatically set the font size depending on the layer scale.", "No|Yes"),
	new cr.Property(ept_text,	"ID (optional)",		"",			"An ID for the control allowing it to be styled with CSS from the page HTML."),
	new cr.Property(ept_text,	"InlineCssText (optional)",			"background-color:transparent; color:black;",			"InlineCssText"),
	new cr.Property(ept_text,	"Idle. Not implemented yet. GlobalCssText (optional)",	 		"",			"GlobalCssText" )
	];
	
// Called by IDE when a new object type is to be created
function CreateIDEObjectType()
{
	return new IDEObjectType();
}

// Class representing an object type in the IDE
function IDEObjectType()
{
	assert2(this instanceof arguments.callee, "Constructor called as a function");
}

// Called by IDE when a new object instance of this type is to be created
IDEObjectType.prototype.CreateInstance = function(instance)
{
	return new IDEInstance(instance);
}

// Class representing an individual instance of an object in the IDE
function IDEInstance(instance, type)
{
	assert2(this instanceof arguments.callee, "Constructor called as a function");
	
	// Save the constructor parameters
	this.instance = instance;
	this.type = type;
	
	// Set the default property values from the property table
	this.properties = {};
	
	for (var i = 0; i < property_list.length; i++)
		this.properties[property_list[i].name] = property_list[i].initial_value;
		
	// Plugin-specific variables
	this.just_inserted = false;
	this.font = null;
}

IDEInstance.prototype.OnCreate = function()
{
	this.instance.SetHotspot(new cr.vector2(0, 0));
}

IDEInstance.prototype.OnInserted = function()
{
	this.instance.SetSize(new cr.vector2(72, 24));
}

IDEInstance.prototype.OnDoubleClicked = function()
{
}

// Called by the IDE after a property has been changed
IDEInstance.prototype.OnPropertyChanged = function(property_name)
{
}

IDEInstance.prototype.OnRendererInit = function(renderer)
{
}
	
//	Called to draw self in the editor
//	TODO what is all of this about? who is a renderer? what to do with div-el?
IDEInstance.prototype.Draw = function(renderer)
{
	var isCheckbox = (this.properties["Type"] === "Checkbox");
	
	if (!this.font)
		this.font = renderer.CreateFont("Arial", 14, false, false);
		
	renderer.SetTexture(null);
	var quad = this.instance.GetBoundingQuad();
	
		renderer.Fill(quad, cr.RGB(224, 224, 224));
		renderer.Outline(quad, cr.RGB(0, 0, 0));
		
		cr.quad.prototype.offset.call(quad, 0, 2);

		/*
		this.font.DrawText(this.properties["Text"],
							quad,
							cr.RGB(0, 0, 0),
							ha_center);
		*/
}

IDEInstance.prototype.OnRendererReleased = function(renderer)
{
	this.font = null;
}